## ros-iron-tvm-vendor 0.9.1

=== CMakeLists.txt ===
# Copyright 2020-2022 The Autoware Foundation, Arm Ltd.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

project(tvm_vendor)

find_package(ros_environment REQUIRED)

set(ROS_VERSION $ENV{ROS_VERSION})

# Default to C99
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 99)
endif()

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(${ROS_VERSION} EQUAL 1)
  cmake_minimum_required(VERSION 2.8.3)

  # find dependencies
  find_package(catkin REQUIRED)
elseif(${ROS_VERSION} EQUAL 2)
  cmake_minimum_required(VERSION 3.5)

  if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    add_compile_options(-Wall -Wextra -Wpedantic)
  endif()

  # find dependencies
  find_package(ament_cmake REQUIRED)
endif()

include(ExternalProject)

set(PATCH_FILE ${CMAKE_CURRENT_SOURCE_DIR}/config.cmake.patch)
if(ROS_VERSION EQUAL 2)
  set(PATCH_FILE ${CMAKE_CURRENT_SOURCE_DIR}/config.cmake.gpu.patch)
endif()

ExternalProject_Add(tvm-build
  GIT_REPOSITORY https://github.com/apache/tvm
  GIT_TAG v0.9.0
  GIT_SHALLOW TRUE
  BUILD_IN_SOURCE TRUE
  PATCH_COMMAND git reset --hard && git apply ${PATCH_FILE}
  COMMAND cp <SOURCE_DIR>/cmake/config.cmake <SOURCE_DIR>
  CONFIGURE_COMMAND ${CMAKE_COMMAND} -DCMAKE_POSITION_INDEPENDENT_CODE=ON .
  INSTALL_COMMAND ""
)

# Build DMLC
ExternalProject_Add_Step(tvm-build dmlc-build
  DEPENDEES patch
  WORKING_DIRECTORY <SOURCE_DIR>/3rdparty/dmlc-core
  COMMAND ${CMAKE_COMMAND} -DCMAKE_POSITION_INDEPENDENT_CODE=ON .
  COMMAND ${CMAKE_MAKE_PROGRAM}
  BYPRODUCTS libdmlc.a
)

ExternalProject_Get_property(tvm-build SOURCE_DIR)

add_library(tvm SHARED IMPORTED
  IMPORTED_LOCATION ${SOURCE_DIR}/libtvm.so
)

add_library(tvm_runtime SHARED IMPORTED
  IMPORTED_LOCATION ${SOURCE_DIR}/libtvm_runtime.so
)

add_library(dmlc STATIC IMPORTED
  IMPORTED_LOCATION ${SOURCE_DIR}/3rdparty/dmlc-core
)

if(${ROS_VERSION} EQUAL 1)
  catkin_package(
    INCLUDE_DIRS include
    LIBRARIES
      tvm
      tvm_runtime
      dmlc
    EXPORTED_TARGETS tvm-build
  )

  add_custom_command(TARGET tvm-build POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_SOURCE_DIR}/include/tvm_vendor/tvm
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${SOURCE_DIR}/include/tvm/runtime/ ${CMAKE_CURRENT_SOURCE_DIR}/include/tvm_vendor/tvm/runtime
    COMMAND ${CMAKE_COMMAND} -E make_directory ${CATKIN_DEVEL_PREFIX}/lib
    COMMAND ${CMAKE_COMMAND} -E copy ${SOURCE_DIR}/libtvm.so ${CATKIN_DEVEL_PREFIX}/lib
    COMMAND ${CMAKE_COMMAND} -E copy ${SOURCE_DIR}/libtvm_runtime.so ${CATKIN_DEVEL_PREFIX}/lib
    COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_SOURCE_DIR}/include/tvm_vendor/dlpack
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${SOURCE_DIR}/3rdparty/dlpack/include/dlpack/dlpack.h ${CMAKE_CURRENT_SOURCE_DIR}/include/tvm_vendor/dlpack/dlpack.h
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${SOURCE_DIR}/3rdparty/dlpack/contrib/dlpack/dlpackcpp.h ${CMAKE_CURRENT_SOURCE_DIR}/include/tvm_vendor/dlpack/dlpackcpp.h
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${SOURCE_DIR}/3rdparty/dmlc-core/include/dmlc/ ${CMAKE_CURRENT_SOURCE_DIR}/include/tvm_vendor/dmlc
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${SOURCE_DIR}/3rdparty/dmlc-core/libdmlc.a ${CATKIN_DEVEL_PREFIX}/lib/libdmlc.a
  )

  install(DIRECTORY ${SOURCE_DIR}/include/tvm/runtime
    DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}/tvm
  )

  install(
    FILES
      ${SOURCE_DIR}/libtvm.so
      ${SOURCE_DIR}/libtvm_runtime.so
    DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  )

  install(
    FILES
      ${SOURCE_DIR}/3rdparty/dlpack/include/dlpack/dlpack.h
      ${SOURCE_DIR}/3rdparty/dlpack/contrib/dlpack/dlpackcpp.h
    DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}/dlpack
  )

  install(DIRECTORY ${SOURCE_DIR}/3rdparty/dmlc-core/include/dmlc
    DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  )
  
  install(FILES ${SOURCE_DIR}/3rdparty/dmlc-core/libdmlc.a
    DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  )
elseif(${ROS_VERSION} EQUAL 2)
  ament_export_include_directories(include include/tvm_vendor)
  ament_export_libraries(tvm tvm_runtime)

  install(DIRECTORY ${SOURCE_DIR}/include/tvm/runtime/
    DESTINATION include/${PROJECT_NAME}/tvm/runtime
  )

  install(
    FILES
      ${SOURCE_DIR}/libtvm.so
      ${SOURCE_DIR}/libtvm_runtime.so
    DESTINATION lib
  )

  install(
    FILES
      ${SOURCE_DIR}/3rdparty/dlpack/include/dlpack/dlpack.h
      ${SOURCE_DIR}/3rdparty/dlpack/contrib/dlpack/dlpackcpp.h
    DESTINATION include/${PROJECT_NAME}/dlpack
  )

  install(DIRECTORY ${SOURCE_DIR}/3rdparty/dmlc-core/include/dmlc
    DESTINATION include/${PROJECT_NAME}
  )

  install(FILES ${SOURCE_DIR}/3rdparty/dmlc-core/libdmlc.a
    DESTINATION lib
  )

  install(
    FILES
      cmake/tvm_runtimeConfig.cmake
      cmake/tvmConfig.cmake
    DESTINATION share/${PROJECT_NAME}/cmake)

  ament_package()
endif()

=== debian/changelog ===
ros-iron-tvm-vendor (0.9.1-3jammy) jammy; urgency=high

  * opencl dependency
  * add opencl to compilation
  * Contributors: Xinyu Wang

 -- Josh Whitley <josh.whitley@autoware.org>  Wed, 09 Nov 2022 16:00:00 -0000

ros-iron-tvm-vendor (0.9.0-3jammy) jammy; urgency=high

  * feat: update tvm version to v0.9.0 (#11 <https://github.com/autowarefoundation/tvm_vendor/issues/11>)
    * feat: update tvm version to v0.9.0
    * ci: fix ros1 ci
  * Contributors: Daisuke Nishimatsu

 -- Josh Whitley <josh.whitley@autoware.org>  Sun, 21 Aug 2022 16:00:00 -0000

ros-iron-tvm-vendor (0.8.2-3jammy) jammy; urgency=high

  * fix: modify patch issue (#10 <https://github.com/autowarefoundation/tvm_vendor/issues/10>)
    * fix: update patch
    * fix: add workaround to avoid multiple patch apply
  * Contributors: Daisuke Nishimatsu

 -- Josh Whitley <josh.whitley@autoware.org>  Sun, 05 Jun 2022 16:00:00 -0000

ros-iron-tvm-vendor (0.8.1-3jammy) jammy; urgency=high

  * feat: support jammy (#9 <https://github.com/autowarefoundation/tvm_vendor/issues/9>)
    * fix CMakeLists.txt to build on jammy
    * ci: update ros2 ci
  * Contributors: Daisuke Nishimatsu

 -- Josh Whitley <josh.whitley@autoware.org>  Tue, 24 May 2022 16:00:00 -0000

ros-iron-tvm-vendor (0.8.0-3jammy) jammy; urgency=high

  * Update TVM version (#7 <https://github.com/autowarefoundation/tvm_vendor/issues/7>)
    This patch is needed to properly run the packages that
    use ML models from the modelzoo.
    Issue-Id: SCM-3720
    Change-Id: I331efb40337ac15ec6b84ed9b9050fa42e49dc0f
  * CI: Add Galactic CI
  * Contributors: Joshua Whitley, Luca Foschiani

 -- Josh Whitley <josh.whitley@autoware.org>  Sun, 06 Feb 2022 16:00:00 -0000

ros-iron-tvm-vendor (0.7.3-3jammy) jammy; urgency=high

  * Merge pull request #6 <https://github.com/autowarefoundation/tvm_vendor/issues/6> from kurcha01-arm/main
    Fix 'No source or binary directory provided'
  * Merge pull request #5 <https://github.com/autowarefoundation/tvm_vendor/issues/5> from kurcha01-arm/main
    Fix header inclusion, export without namespacing
  * Merge pull request #4 <https://github.com/autowarefoundation/tvm_vendor/issues/4> from kurcha01-arm/main
    Fix dlpack and tvm-runtime header inclusion
  * Merge pull request #3 <https://github.com/autowarefoundation/tvm_vendor/issues/3> from ambroise-arm/vulkan-backend
    Add Vulkan backend
  * Contributors: Ambroise Vincent, Joshua Whitley, Kurtis Charnock

 -- Josh Whitley <josh.whitley@autoware.org>  Mon, 07 Jun 2021 16:00:00 -0000

ros-iron-tvm-vendor (0.7.2-3jammy) jammy; urgency=high

  * Removing LLVM dependency.
  * Contributors: Joshua Whitley

 -- Josh Whitley <josh.whitley@autoware.org>  Tue, 08 Dec 2020 16:00:00 -0000

ros-iron-tvm-vendor (0.7.1-3jammy) jammy; urgency=high

  * Updating LLVM dependency.
  * Moving catkin_package() back to after add_library().
  * Contributors: Joshua Whitley

 -- Josh Whitley <josh.whitley@autoware.org>  Mon, 30 Nov 2020 16:00:00 -0000

ros-iron-tvm-vendor (0.7.0-3jammy) jammy; urgency=high

  * Initial release.
  * Contributors: Joshua Whitley

 -- Josh Whitley <josh.whitley@autoware.org>  Sun, 15 Nov 2020 16:00:00 -0000

=== debian/control ===
Source: ros-iron-tvm-vendor
Section: misc
Priority: optional
Maintainer: Josh Whitley <josh.whitley@autoware.org>
Build-Depends: debhelper (>= 9.0.0), git, libopenblas-dev, libvulkan-dev, libxml2-dev, ocl-icd-opencl-dev, opencl-headers, ros-iron-ament-cmake, ros-iron-ros-environment, spirv-headers, spirv-tools, ros-iron-ros-workspace
Homepage: https://tvm.apache.org/
Standards-Version: 3.9.2

Package: ros-iron-tvm-vendor
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, git, libopenblas-dev, libvulkan-dev, libxml2-dev, ocl-icd-opencl-dev, opencl-headers, spirv-headers, spirv-tools, ros-iron-ros-workspace
Description: Wrapper around Apache TVM to make it available to the ROS ecosystem.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/iron/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/iron" \
		-DAMENT_PREFIX_PATH="/opt/ros/iron" \
		-DCMAKE_PREFIX_PATH="/opt/ros/iron" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-iron-tvm-vendor//opt/ros/iron/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_install
